"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fibers = require("fibers");
function isFunction(fn) {
    if (typeof fn !== 'function')
        throw new Error('Not a function');
}
var Fiberit = /** @class */ (function () {
    function Fiberit() {
    }
    Fiberit.launchFiber = function (fn) {
        var restParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            restParams[_i - 1] = arguments[_i];
        }
        isFunction(fn);
        return fibers(function () { fn.apply(null, restParams); }).run();
    };
    Fiberit.for = function (asyncFunction) {
        var restParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            restParams[_i - 1] = arguments[_i];
        }
        isFunction(asyncFunction);
        return Fiberit.applyAndWait(asyncFunction, restParams);
    };
    Fiberit.forMethod = function (obj, methodName) {
        var restParams = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            restParams[_i - 2] = arguments[_i];
        }
        var method = obj[methodName].bind(obj); // TODO this breaks signature from method, if method return string and V is set as number, will compile.
        return Fiberit.applyAndWait(method, restParams);
    };
    Fiberit.forPromise = function (obj, methodName) {
        var restParams = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            restParams[_i - 2] = arguments[_i];
        }
        var promise = obj[methodName].apply(obj, restParams); // TODO this breaks signature from method, if method return string and V is set as number, will compile.
        return Fiberit.applyAndWaitPromise(promise);
    };
    Fiberit.forPromisedMethod = function (promisedFunction) {
        var restParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            restParams[_i - 1] = arguments[_i];
        }
        isFunction(promisedFunction);
        var promise = promisedFunction.apply(promisedFunction, restParams); // TODO this breaks signature from method, if method return string and V is set as number, will compile.
        return Fiberit.applyAndWaitPromise(promise);
    };
    Fiberit.applyAndWait = function (fn, args) {
        var fiber = fibers.current;
        if (!fiber)
            throw new Error('Async method can only be called inside a Fiber.');
        var resumeCallback = function (err, data) {
            if (fiber.callbackAlreadyCalled) {
                throw new Error("Callback for function " + fn.name + " called twice. Fiberit already resumed the execution.");
            }
            fiber.callbackAlreadyCalled = true;
            fiber.err = err;
            fiber.data = data;
            if (fiber.yielded) {
                fiber.run();
            }
            else {
                return;
            }
        };
        args.push(resumeCallback);
        fiber.callbackAlreadyCalled = false;
        fiber.yielded = false;
        fn.apply(null, args);
        if (!fiber.callbackAlreadyCalled) {
            fiber.yielded = true;
            fibers.yield();
        }
        if (fiber.err)
            throw fiber.err;
        return fiber.data;
    };
    Fiberit.applyAndWaitPromise = function (promise) {
        var promiseCallback = function (cb) {
            promise
                .then(function (data) {
                cb(null, data);
            })
                .catch(function (error) {
                cb(error);
            });
        };
        return this.for(promiseCallback);
    };
    return Fiberit;
}());
exports.Fiberit = Fiberit;
//# sourceMappingURL=fiberit.js.map