export declare class Parallel {
    /**
     * Executes the syncFunctionOrFunctionWithFiber in parallel over the array values.
     * Accepts a function that is either synchronous or uses coroutines internally (Fiberit).
     * Hint: when there's an error like "callback already called" is that
     * there's a runtime error not managed from async
     * @param array A[]
     * @param syncFunctionOrFunctionWithFiber (A)=>B
     * @returns B[]
     * @throws Error
     */
    static map<A, B>(array: A[], syncFunctionOrFunctionWithFiber: (param: A) => B): B[];
    static zipMap<A, B>(functs: ReadonlyArray<(a: A) => B>, values: A[]): B[];
    static zipMapWith<A, B>(functs: ((...args: A[]) => B)[], values: A[][]): any[];
    static withData<A, B>(array: A[]): (action: (param: A) => B) => B[];
    static pool<A, B>(size: number, data: ReadonlyArray<A>, mapper: (...rest: A[]) => B): B[];
    static poolWith<A, B>(size: number, data: ReadonlyArray<A[]>, mapper: (...rest: A[]) => B): B[];
    private static mapAsync;
}
